package com.example.trefletest.models
import com.google.gson.annotations.SerializedName


data class Plant(
    @SerializedName("data")
    val `data`: Data,
    @SerializedName("meta")
    val meta: Meta
) {
    data class Data(
        @SerializedName("author")
        val author: String,
        @SerializedName("bibliography")
        val bibliography: String,
        @SerializedName("common_name")
        val commonName: Any?,
        @SerializedName("family")
        val family: Family,
        @SerializedName("family_common_name")
        val familyCommonName: Any?,
        @SerializedName("forms")
        val forms: List<Any>,
        @SerializedName("genus")
        val genus: Genus,
        @SerializedName("genus_id")
        val genusId: Int,
        @SerializedName("hybrids")
        val hybrids: List<Any>,
        @SerializedName("id")
        val id: Int,
        @SerializedName("image_url")
        val imageUrl: String,
        @SerializedName("links")
        val links: Links,
        @SerializedName("main_species")
        val mainSpecies: MainSpecies,
        @SerializedName("main_species_id")
        val mainSpeciesId: Int,
        @SerializedName("observations")
        val observations: String,
        @SerializedName("scientific_name")
        val scientificName: String,
        @SerializedName("slug")
        val slug: String,
        @SerializedName("sources")
        val sources: List<Source>,
        @SerializedName("species")
        val species: List<Specy>,
        @SerializedName("subspecies")
        val subspecies: List<Any>,
        @SerializedName("subvarieties")
        val subvarieties: List<Any>,
        @SerializedName("varieties")
        val varieties: List<Any>,
        @SerializedName("vegetable")
        val vegetable: Boolean,
        @SerializedName("year")
        val year: Int
    ) {
        data class Family(
            @SerializedName("common_name")
            val commonName: Any?,
            @SerializedName("id")
            val id: Int,
            @SerializedName("links")
            val links: Links,
            @SerializedName("name")
            val name: String,
            @SerializedName("slug")
            val slug: String
        ) {
            data class Links(
                @SerializedName("division_order")
                val divisionOrder: String,
                @SerializedName("genus")
                val genus: String,
                @SerializedName("self")
                val self: String
            )
        }

        data class Genus(
            @SerializedName("id")
            val id: Int,
            @SerializedName("links")
            val links: Links,
            @SerializedName("name")
            val name: String,
            @SerializedName("slug")
            val slug: String
        ) {
            data class Links(
                @SerializedName("family")
                val family: String,
                @SerializedName("plants")
                val plants: String,
                @SerializedName("self")
                val self: String,
                @SerializedName("species")
                val species: String
            )
        }

        data class Links(
            @SerializedName("genus")
            val genus: String,
            @SerializedName("self")
            val self: String,
            @SerializedName("species")
            val species: String
        )

        data class MainSpecies(
            @SerializedName("author")
            val author: String,
            @SerializedName("bibliography")
            val bibliography: String,
            @SerializedName("common_name")
            val commonName: Any?,
            @SerializedName("common_names")
            val commonNames: CommonNames,
            @SerializedName("distribution")
            val distribution: Distribution,
            @SerializedName("distributions")
            val distributions: Distributions,
            @SerializedName("duration")
            val duration: Any?,
            @SerializedName("edible")
            val edible: Boolean,
            @SerializedName("edible_part")
            val ediblePart: Any?,
            @SerializedName("family")
            val family: String,
            @SerializedName("family_common_name")
            val familyCommonName: Any?,
            @SerializedName("flower")
            val flower: Flower,
            @SerializedName("foliage")
            val foliage: Foliage,
            @SerializedName("fruit_or_seed")
            val fruitOrSeed: FruitOrSeed,
            @SerializedName("genus")
            val genus: String,
            @SerializedName("genus_id")
            val genusId: Int,
            @SerializedName("growth")
            val growth: Growth,
            @SerializedName("id")
            val id: Int,
            @SerializedName("image_url")
            val imageUrl: String,
            @SerializedName("images")
            val images: Images,
            @SerializedName("links")
            val links: Links,
            @SerializedName("observations")
            val observations: String,
            @SerializedName("rank")
            val rank: String,
            @SerializedName("scientific_name")
            val scientificName: String,
            @SerializedName("slug")
            val slug: String,
            @SerializedName("sources")
            val sources: List<Source>,
            @SerializedName("specifications")
            val specifications: Specifications,
            @SerializedName("status")
            val status: String,
            @SerializedName("synonyms")
            val synonyms: List<Any>,
            @SerializedName("vegetable")
            val vegetable: Boolean,
            @SerializedName("year")
            val year: Int
        ) {
            class CommonNames(
            )

            data class Distribution(
                @SerializedName("native")
                val native: List<String>
            )

            data class Distributions(
                @SerializedName("native")
                val native: List<Native>
            ) {
                data class Native(
                    @SerializedName("id")
                    val id: Int,
                    @SerializedName("links")
                    val links: Links,
                    @SerializedName("name")
                    val name: String,
                    @SerializedName("slug")
                    val slug: String,
                    @SerializedName("species_count")
                    val speciesCount: Int,
                    @SerializedName("tdwg_code")
                    val tdwgCode: String,
                    @SerializedName("tdwg_level")
                    val tdwgLevel: Int
                ) {
                    data class Links(
                        @SerializedName("plants")
                        val plants: String,
                        @SerializedName("self")
                        val self: String,
                        @SerializedName("species")
                        val species: String
                    )
                }
            }

            data class Flower(
                @SerializedName("color")
                val color: Any?,
                @SerializedName("conspicuous")
                val conspicuous: Any?
            )

            data class Foliage(
                @SerializedName("color")
                val color: Any?,
                @SerializedName("leaf_retention")
                val leafRetention: Any?,
                @SerializedName("texture")
                val texture: Any?
            )

            data class FruitOrSeed(
                @SerializedName("color")
                val color: Any?,
                @SerializedName("conspicuous")
                val conspicuous: Any?,
                @SerializedName("seed_persistence")
                val seedPersistence: Any?,
                @SerializedName("shape")
                val shape: Any?
            )

            data class Growth(
                @SerializedName("atmospheric_humidity")
                val atmosphericHumidity: Any?,
                @SerializedName("bloom_months")
                val bloomMonths: Any?,
                @SerializedName("days_to_harvest")
                val daysToHarvest: Any?,
                @SerializedName("description")
                val description: Any?,
                @SerializedName("fruit_months")
                val fruitMonths: Any?,
                @SerializedName("growth_months")
                val growthMonths: Any?,
                @SerializedName("light")
                val light: Any?,
                @SerializedName("maximum_precipitation")
                val maximumPrecipitation: MaximumPrecipitation,
                @SerializedName("maximum_temperature")
                val maximumTemperature: MaximumTemperature,
                @SerializedName("minimum_precipitation")
                val minimumPrecipitation: MinimumPrecipitation,
                @SerializedName("minimum_root_depth")
                val minimumRootDepth: MinimumRootDepth,
                @SerializedName("minimum_temperature")
                val minimumTemperature: MinimumTemperature,
                @SerializedName("ph_maximum")
                val phMaximum: Any?,
                @SerializedName("ph_minimum")
                val phMinimum: Any?,
                @SerializedName("row_spacing")
                val rowSpacing: RowSpacing,
                @SerializedName("soil_humidity")
                val soilHumidity: Any?,
                @SerializedName("soil_nutriments")
                val soilNutriments: Any?,
                @SerializedName("soil_salinity")
                val soilSalinity: Any?,
                @SerializedName("soil_texture")
                val soilTexture: Any?,
                @SerializedName("sowing")
                val sowing: Any?,
                @SerializedName("spread")
                val spread: Spread
            ) {
                data class MaximumPrecipitation(
                    @SerializedName("mm")
                    val mm: Any?
                )

                data class MaximumTemperature(
                    @SerializedName("deg_c")
                    val degC: Any?,
                    @SerializedName("deg_f")
                    val degF: Any?
                )

                data class MinimumPrecipitation(
                    @SerializedName("mm")
                    val mm: Any?
                )

                data class MinimumRootDepth(
                    @SerializedName("cm")
                    val cm: Any?
                )

                data class MinimumTemperature(
                    @SerializedName("deg_c")
                    val degC: Any?,
                    @SerializedName("deg_f")
                    val degF: Any?
                )

                data class RowSpacing(
                    @SerializedName("cm")
                    val cm: Any?
                )

                data class Spread(
                    @SerializedName("cm")
                    val cm: Any?
                )
            }

            data class Images(
                @SerializedName("bark")
                val bark: List<Any>,
                @SerializedName("flower")
                val flower: List<Flower>,
                @SerializedName("fruit")
                val fruit: List<Any>,
                @SerializedName("habit")
                val habit: List<Any>,
                @SerializedName("leaf")
                val leaf: List<Any>,
                @SerializedName("other")
                val other: List<Any>
            ) {
                data class Flower(
                    @SerializedName("copyright")
                    val copyright: String,
                    @SerializedName("id")
                    val id: Int,
                    @SerializedName("image_url")
                    val imageUrl: String
                )
            }

            data class Links(
                @SerializedName("genus")
                val genus: String,
                @SerializedName("plant")
                val plant: String,
                @SerializedName("self")
                val self: String
            )

            data class Source(
                @SerializedName("citation")
                val citation: String?,
                @SerializedName("id")
                val id: String,
                @SerializedName("last_update")
                val lastUpdate: String,
                @SerializedName("name")
                val name: String,
                @SerializedName("url")
                val url: String
            )

            data class Specifications(
                @SerializedName("average_height")
                val averageHeight: AverageHeight,
                @SerializedName("growth_form")
                val growthForm: Any?,
                @SerializedName("growth_habit")
                val growthHabit: Any?,
                @SerializedName("growth_rate")
                val growthRate: Any?,
                @SerializedName("ligneous_type")
                val ligneousType: Any?,
                @SerializedName("maximum_height")
                val maximumHeight: MaximumHeight,
                @SerializedName("nitrogen_fixation")
                val nitrogenFixation: Any?,
                @SerializedName("shape_and_orientation")
                val shapeAndOrientation: Any?,
                @SerializedName("toxicity")
                val toxicity: Any?
            ) {
                data class AverageHeight(
                    @SerializedName("cm")
                    val cm: Any?
                )

                data class MaximumHeight(
                    @SerializedName("cm")
                    val cm: Any?
                )
            }
        }

        data class Source(
            @SerializedName("citation")
            val citation: String?,
            @SerializedName("id")
            val id: String,
            @SerializedName("last_update")
            val lastUpdate: String,
            @SerializedName("name")
            val name: String,
            @SerializedName("url")
            val url: String
        )

        data class Specy(
            @SerializedName("author")
            val author: String,
            @SerializedName("bibliography")
            val bibliography: String,
            @SerializedName("common_name")
            val commonName: Any?,
            @SerializedName("family")
            val family: String,
            @SerializedName("family_common_name")
            val familyCommonName: Any?,
            @SerializedName("genus")
            val genus: String,
            @SerializedName("genus_id")
            val genusId: Int,
            @SerializedName("id")
            val id: Int,
            @SerializedName("image_url")
            val imageUrl: String,
            @SerializedName("links")
            val links: Links,
            @SerializedName("rank")
            val rank: String,
            @SerializedName("scientific_name")
            val scientificName: String,
            @SerializedName("slug")
            val slug: String,
            @SerializedName("status")
            val status: String,
            @SerializedName("synonyms")
            val synonyms: List<Any>,
            @SerializedName("year")
            val year: Int
        ) {
            data class Links(
                @SerializedName("genus")
                val genus: String,
                @SerializedName("plant")
                val plant: String,
                @SerializedName("self")
                val self: String
            )
        }
    }

    data class Meta(
        @SerializedName("last_modified")
        val lastModified: String
    )
}